<?php
if (!defined('PmWiki')  || !defined('XAJAXSEARCH'))
	exit ();

/**
 * This package replace the pmwiki search view with a new one
 * which allows to preview pages
 * <br>
 * This file contains function which are called by XAJAX 
 * @package xajaxsearch
 */


/**
 * Perform a search and update the search results
 * 
 * @param array $aFormValues keys: pagename, searchterm
 */
function ajaxFmtPageList($aFormValues, $args='') {
	$out = searchPerformAjax($aFormValues['pagename'], $aFormValues['searchterm']);

	$objResponse = new xajaxResponse();
	
	$args = ParseArgs(stripmagic($args));
	$args['searchterm'] = $aFormValues['searchterm'];
	$outargs = GenerateArgs($args);
	$objResponse->addAssign("xajaxargs", "innerHTML", $outargs);
	
	$objResponse->addAssign("submitButton", "disabled", false);
	$objResponse->addAssign("searchresultsajax", "innerHTML", $out);

	$preview = FmtPageName("$[Preview]", $out);
	$objResponse->addAssign("previewname", "innerHTML", $preview);
	$objResponse->addAssign("previewpage", "innerHTML", "");

	return $objResponse->getXML();
}

/**
 * Show page previews
 * 
 * @param array $aFormValues keys: pagename, searchterm
 */
function ajaxShowPage($pagename, $args='') {
	$args = ParseArgs(stripmagic($args));
	
	$page = ReadPage($pagename);
	$out = MarkupToHtml($pagename, $page['text']);
	

	$words = preg_replace("/\\s+/","|",$args['searchterm']);
	$out = preg_replace("/\\b($words)\\b(?![^<]*>)/i", "<font style='background:yellow;'>$1</font>", $out);
	
	
	$objResponse = new xajaxResponse();
	$objResponse->addAssign("previewname", "innerHTML", FmtPageName("$[Preview] - $pagename", $pagename));
	$objResponse->addAssign("previewpage", "innerHTML", $out);
	$objResponse->addAssign("dd".$pagename, "style.fontStyle", "italic");
	$objResponse->addAssign("dd".$pagename, "style.fontWeight", "bold");
	
	if ($args['oldpagename'] != 'empty' && $args['oldpagename'] != $pagename)
		$objResponse->addAssign("dd".$args['oldpagename'], "style.fontWeight", "normal");

	$args['oldpagename'] = $pagename;
	$outargs = GenerateArgs($args);
	$objResponse->addAssign("xajaxargs", "innerHTML", $outargs);

	return $objResponse->getXML();
}

function ajaxShowWaitWheelInDiv($div, $prefix="") {
	global $PubDirUrl;
	$objResponse = new xajaxResponse();
	$objResponse->addAssign($div, "innerHTML", stripmagic($prefix)."<div style='text-align:center;'><img src='".$PubDirUrl."/cookbook/xajaxsearch/waiting.gif'/></div>");
	return $objResponse->getXML();
}


?>